/******************************************************************************
                                    ZENKIN.C
                           by Kyosuke YUKI 92/11/20
                           by dc       93/03/05
******************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

#define		BUFMAX			2048

#define		STRPTR(x,y)		((x)+(((y)*2)-2))
#define		STRHANG(x)		(((x)*2)-2)
#define		FALSE			0
#define		TRUE			!FALSE
#define		FAILURE			0
#define		SUCCESS			!FAILURE
#define		ATAMAKIN		0
#define		SIPPOKIN		1

#define		KANJI_FS1		0x81
#define		KANJI_FE1		0x9F
#define		KANJI_FS2		0xE0
#define		KANJI_FE2		0xFC

char *zenkin(char *src, char *dest, int width);
int alignment(char *src, char *work);
int iszenkin(char *argchar, int mode);
int iskanjifirst(char *work, int i);

/******************************************************************** zenkin */

char *zenkin(char *src, char *dest, int width)
{
	int first = 1, nextfirst;
	int i, count = 0;
	size_t zenlen;		/* unsigned int zenlen; */
	char work[BUFMAX+1];	/* nɂĂ̓X^bNI[o[t[ɒ */
						/* alloca()g΂̕ǂ */
	
	if( strlen(src)>BUFMAX-1 ){	/* 悤Ƃ镶񂪂Ȃ */
		return NULL;
	}
	
	if (alignment(src, work) == FAILURE) {	/* Sp̃ACg */
		return NULL;
	}
	zenlen = strlen(work) / 2;			/* Ŝ̕iSpŌvZj */
	nextfirst = first + width;			/* nextfirst́As擪ڌ */

	while (zenlen >= nextfirst) {		/* Ō̍słȂ΋֑Jn */
		if ((iszenkin(STRPTR(work, nextfirst - 1), SIPPOKIN) == TRUE)
		 && (width != 1)) {				/* ss֑H */
			for (--nextfirst, i = 1;
			iszenkin(STRPTR(work, nextfirst - 1), SIPPOKIN) == TRUE;
			nextfirst--, i++) {			/* s֑ȂȂ܂ők */
				if (i == width - 1) {
					break;				/* s܂őkĂ܂give up */
				}
			}
		} else {						/* sss֑H */
			if (iszenkin(STRPTR(work, nextfirst), ATAMAKIN) == TRUE) {
				if ((iszenkin(STRPTR(work, nextfirst + 1), ATAMAKIN) == TRUE)
				 && (width != 1)) {		/* ̕s֑H */
					for (--nextfirst, i = 1;
					iszenkin(STRPTR(work, nextfirst), ATAMAKIN) == TRUE;
					nextfirst--, i++) {	/* Os̍s֑ȊO܂ők */
						if (i == width - 1) {
							break;		/* s܂őkĂ܂give up */
						}
					}
				} else {
					nextfirst++;		/* ʂ̂Ԃ炳֑łnj */
				}
			}
		}
		for (i = STRHANG(first); i < STRHANG(nextfirst); i++) {
			dest[count++] = work[i];	/* sRs[ */
		}
		dest[count++] = '\n';			/* sR[h} */
		first = nextfirst;				/* s̐擪 */
		nextfirst = first + width;		/* s̐擪ڌ */
	}

	if (*STRPTR(work, first) != NULL) {	/* Ō̍sNULLłȂȂ */
		for (i = STRHANG(first); work[i] != NULL; i++) {
			dest[count++] = work[i];	/* Ō܂ŃRs[ */
		}
		dest[count++] = '\n';			/* Ōs̉sR[h} */
	}
	dest[count++] = NULL;				/* k^[~l[^ŊW */

	return dest;
}

/***************************************************************** alignment */

int alignment(char *src, char *work)
{
	int i, k, flg;
	char c;

	for (k = 0, i = 0; (c = *(src + i)) != NULL; i++) {
		if (c == '\n') {				/* sR[h폜 */
			continue;
		}
		*(src + (k++)) = c;
	}
	*(src + k) = NULL;

	for (k = 0, i = 0, flg = 1; (c = *(src + i)) != NULL; i++) {
		if ((i % 2) == flg) {			/* oCgڂ */
			if (iskanjifirst(src, i) == TRUE) {	/* KYɂȂ悤 */
				*(work + (k++)) = ' ';
				if (k >= BUFMAX) {		/* ӂh~ */
					return FAILURE;
				}
				flg = (!flg);
			}
		}
		*(work + (k++)) = c;
		if (k >= BUFMAX) {				/* ӂh~ */
			return FAILURE;
		}
	}
	*(work + k) = NULL;
	return SUCCESS;
}

/****************************************************************** iszenkin */

int iszenkin(char *argchar, int mode)
{
	int i;
	char **kinsoku;
	char *atamakin[] ={"A", "B", "C", "D", "@",
					   "z", "x", "v", "t", "r", "p", "n", "l",
					   "j", "h", "F", "G", "H", "I", "!?",
					   "", "", "", "", "",
					   "", "", "", "", "",
					   "@", "B", "D", "F", "H",
					   "b", "", "", "", "",
					   "", "[",
					   "|", "c", "R", "S", "T", "U", NULL};
	char *sippokin[] ={"y", "w", "u", "s", "q", "o", "m", "k",
					   "i", "g", NULL};

	kinsoku = (mode == ATAMAKIN) ? atamakin : sippokin;
	for (i = 0; kinsoku[i] != NULL; i++) {
		if ((*argchar == kinsoku[i][0]) && (*(argchar + 1) == kinsoku[i][1])) {
			return TRUE;
		}
	}
	return FALSE;
}

/************************************************************** iskanjifirst */

int iskanjifirst(char *work, int i)
{
	int c;

	c = *(work + i) & 0xFF;
	if (!((c >= KANJI_FS1) && (c <= KANJI_FE1)
	   || (c >= KANJI_FS2) && (c <= KANJI_FE2))) {
		return FALSE;
	}
	if (iskanjifirst(work, i - 1) && (i > 0)) {
		return FALSE;
	}
	return TRUE;
}

/*****************************************************************************/

